#!/usr/bin/perl -w

use strict;
use Fcntl;

# Run tcpdump, and watch for nasty stuff.  Eventually block the site
# with either iptables or ipchains.

package main;
our $prefix = "/var/.sniffer";
our $logdir = "$prefix/spool";
our $lockFile = "$prefix/lock/web-watch.lck";
our $counter = 1;
our $filename = "";
our $isArp = "no";
our $payload = "";
our @hexes = ();
our $hex = "";
our $hexOne = "";
our $hexTwo = "";
our $charOne = "";
our $charTwo = "";

# Determine if the character is printable
sub isKosher ( $ ) {
    my $mychar = shift;
    if ( ( ( $mychar > 31 ) and ( $mychar < 127 ) ) or ( $mychar == 10 ) ) {
	return 1;
    } else {
	return 0;
    }
}

# Clean up from kill -15
sub killFifteen () {
    unlink ( $lockFile );
    print "web-watch.pl: Terminated\n";
    exit ( 0 );
}

# Become a daemon
if ( fork () == 0 ) {
    # child; do nothing
} else {
    # parent; die to become a daemon
    exit ( 0 );
}

# Attempt to create my lock file
sysopen ( LCK, $lockFile, O_CREAT|O_EXCL|O_RDWR ) or die "unable to create $lockFile: $!";
print LCK "$$\n";
close ( LCK );

# Register my kill -15 handler
$SIG{TERM} = \&killFifteen;

# Start the other components.
system ( "$prefix/web-log.pl" );
system ( "$prefix/web-block.pl" );
system ( "$prefix/web-scan.pl" );

# Clear the spool directory every time we start up.
`cd $logdir ; rm -f *`;

open ( SRC, "/usr/sbin/tcpdump -n -l -s 10000 -x|");
open ( SCAN, ">$prefix/pipes/scan-pipe" );
$| = 1; # Autoflush after each write

while ( <SRC> ) {
#    print "$_";

    if ( /\S+\sarp/ ) {
	$isArp = "yes";
    }

    if ( /^\S+\s(\S+)\s\S+\s(\S+)\:/ ) {
	# Header info
	$isArp = "no";
	# Write out the payload from the last packet here
	if ( $filename ne "" ) {
	    open ( WRT, ">$logdir/$filename" );
	    print WRT "$payload";
	    close ( WRT );
#	    print "$filename\n$payload\n----------------------------\n";
	    $payload = "";
	    print SCAN "$filename\n";
	}
#	print "$payload\n";
#	$payload = "";
	$filename = "$1-$2-$counter";
	$counter++;
    } else {
	if ( $isArp eq "no" ) {
	    @hexes = split;
	    foreach $hex (@hexes) {
		$hexOne = substr ($hex, 0, 2);
		$hexTwo = substr ($hex, 2, 2);
		$charOne = hex ( $hexOne );
		$charTwo = hex ( $hexTwo );
		if ( isKosher ( $charOne ) ) {
		    $payload .= chr ( $charOne );
		}
		if ( isKosher ( $charTwo ) ) {
		    $payload .= chr ( $charTwo );
		}
	    }
	}
    }
}

